d("productListPageView",['util', 'plpSortView', 'searchModel'], function(UTIL,plpSortView, searchModel) {

    return {

        extendproductListPageView: function() {
                let filterKey = ['Name', 'Publication', 'Language', 'Color', 'Layout', 'Genre'];
                $(document).ready(function(){
                    window.addEventListener("scroll", function () {
                        initScroll();
                    }, false);
                });
                function initScroll() {
                    if ($(document).height()== Math.round($(window).scrollTop()+$(window).height())) {
                        /*console.log('document height: ' + $(document).height());
                        console.log('window scrollTop: ' + $(window).scrollTop());
                        console.log('document scrollTop: ' + $(document).scrollTop());
                        console.log('window height: ' + $(window).height());
                        console.log('total: ' + ($(window).scrollTop()+$(window).height()));
                        console.log('total with doc: ' + ($(document).scrollTop()+$(window).height()));*/
                        if(CCRZ.productListPageView){
                            if(CCRZ.productListPageView.model.get('isReprint') && CCRZ.productListPageView.model.get('isEndOfPageRender')){
                                console.log("you're at the bottom of the page");
                                let originalList = CCRZ.productListPageView.model.get('originalReprintList');
                                if(originalList.length < CCRZ.productListPageView.model.get('prodCount')){
                                    let sortBy = CCRZ.productListPageView.model.get('sortBy'), sortOrder = CCRZ.productListPageView.model.get('sortOrder');
                                    let reqData = {
                                        'searchText': CCRZ.productListPageView.model.get('searchText') + ' not EXCLUDE',
                                        'type': 'search',
                                        'UD_C64_1' : '1.0 Approved for Publication',
                                        'sortType': (sortOrder == 'asc'?'+':'-') + sortBy,
                                        'offset': CCRZ.productListPageView.model.get('renderedCount') + '',
                                        'pageSize': CCRZ.productListPageView.model.get('reprintSize') + '',
                                        'isPDP' : false
                                    }
                                    filterKey.forEach(function(key){
                                        let filterList = CCRZ.productListPageView.model.attributes['filter_' + key];
                                        if(filterList.length > 0){
                                            reqData['filter' + key] = filterList[0];
                                        }
                                    });
                                    UTIL.showLoader();
                                    CCRZ.productListPageView.model.set('isEndOfPageRender', false);
                                    UTIL.disableScroll();
                                    console.log('End of page callout started!');
                                    CCRZ.productListPageView.productItemsView.fetchReprint(reqData, true);
                                }
                            }
                        }
                        
                    }
                };
                CCRZ.productListPageViewWasRendered = false;
                CCRZ.pubSub.on("view:productListPageView:refresh", function(view) {
                    if(!CCRZ.productListPageViewWasRendered){
                        plpSortView.extendSortView(view);
                        $('.productListContent').addClass('all-products-list');
                        let searchText = typeof CCRZ.pagevars.queryParams.searchText == 'undefined'?"":CCRZ.pagevars.queryParams.searchText;
                        CCRZ.productListPageView.model.set('searchText', (searchText == '')?'':searchText);
                        CCRZ.productListPageView.model.set('isReprint', (searchText == '')?false:true);
                        CCRZ.productListPageViewWasRendered = true;
                        CCRZ.productListPageView.model.set('layout', "grid");
                        CCRZ.productListPageView.model.set('sortBy', (CCRZ.productListPageView.model.attributes.isReprint)?'pubDate':'sfdcName');
                        CCRZ.productListPageView.model.set('pageSize', CCRZ.pagevars.isGuest?100:100);
                        CCRZ.productListPageView.productItemsView.model.set('isRender', false);
                        CCRZ.productListPageView.headerView.setElement(CCRZ.uiProperties.productListPageView.header.selector);
                        CCRZ.productListPageView.productItemsView.itemViews = [];
                        CCRZ.productListPageView.productItemsView.setElement(CCRZ.uiProperties.productListPageView.productItems.selector);
                        CCRZ.productListPageView.footerView.setElement(CCRZ.uiProperties.productListPageView.footer.selector);
                        CCRZ.productListPageView.productItemsView.renderDesktop = function () {
                            var v = this, isReprint = CCRZ.productListPageView.model.get('isReprint');
                            v.$el.empty();
                            v.delegateEvents();
                            v.$el.toggleClass('cc_grid_container', v.model.get('layout') == 'grid');
                            var container = document.createDocumentFragment();
                            if(CCRZ.productListPageView.productItemsView.model.get('isRender')){
                                _.each(v.itemViews, function(item){
                                container.appendChild(item.render().el);
                                if(v.model.get('layout') == 'grid' && (item.model.get('index')+1) % 3 == 0){
                                var clear = document.createElement("div");
                                clear.className = 'clearfix'
                                container.appendChild(clear);
                                }
                                });
                                v.$el.append(container);
                        
                                if(this.pickerView){
                                this.pickerView.render(true);
                                }
                            }
                            return this;
                        };
                        CCRZ.productListPageView.productItemsView.delegateEvents();
                    }
                });
                CCRZ.pubSub.on("view:productListFilterView:refresh", function(filterView) {
                    filterView.specGroupsView.setElement(CCRZ.uiProperties.productListFilterView.ListView.selector);
                    //On load fix for UI Slider (Wordaround)
                    setTimeout(function(){
                        filterView.specGroupsView.postRender();
                    }, 1000);
                });
                CCRZ.pubSub.on("view:productListHeader:refresh", function(prodHeaderView) {
                    prodHeaderView.events["click .cc_remove_filters"] = 'removeAllFilters';
                    prodHeaderView.removeAllFilters = function(event){
                        CCRZ.pubSub.trigger("view:" + this.viewName + ":removeAllFilters");
                        setTimeout(function(){
                            CCRZ.productListFilterView.specGroupsView.postRender();
                        }, 1500);
                    }
                    prodHeaderView.delegateEvents();
                });
                CCRZ.pubSub.on("action:productsPageRenderAllViews", function() {
                    CCRZ.productListPageView.render();
                    CCRZ.productListPageView.headerView.render();
                    CCRZ.productListFilterView.specGroupsView.render(); /// Add it for  for Product Specs
                    CCRZ.productListPageView.productItemsView.render();
                    CCRZ.productListPageView.footerView.render();
                });

                let isProductItemsRefreshed = false;
                CCRZ.pubSub.on("view:productItemsView:refresh", function(itemsView) {
                    if(!isProductItemsRefreshed){
                        itemsView.events['click .addToWishList'] = 'handleWishListPicker';
                        itemsView.handleWishListPicker = function(event){
                            event.preventDefault();
                            let id = event.currentTarget.dataset.id;
                            $('#addToWish_' + id).modal({backdrop: true, show: true}); 
                            $('#addToWish_' + id).removeClass('fade');
                            $('.modal-backdrop').removeClass('fade');
                            this.pickerView.render();
                        };
                        itemsView.renderDesktop = function () {
                            var v = this, isReprint = CCRZ.productListPageView.model.get('isReprint'), isHideLoader = true;
                            v.$el.empty();
                            v.delegateEvents();
                            v.$el.toggleClass('cc_grid_container', v.model.get('layout') == 'grid');
                            if(!isReprint){
                                v.processItems();
                            }
                            var container = document.createDocumentFragment();
                            if(CCRZ.productListPageView.productItemsView.model.get('isRender')){
                                _.each(v.itemViews, function(item){
                                container.appendChild(item.render().el);
                                if(v.model.get('layout') == 'grid' && (item.model.get('index')+1) % 3 == 0){
                                var clear = document.createElement("div");
                                clear.className = 'clearfix'
                                container.appendChild(clear);
                                }
                                });
                                v.$el.append(container);
                        
                                if(this.pickerView){
                                this.pickerView.render(true);
                                }
                                if((isReprint && isHideLoader) || !isReprint){
                                    UTIL.hideLoader();
                                    CCRZ.productListPageView.model.set('isEndOfPageRender', true);
                                    UTIL.enableScroll();
                                }
                            }
                            return this;
                        };
                        itemsView.fetchReprint = function(reqData, isAdd){
                            let _this = this;
                            CCRZ.remoteModel.merlinOneSearch(JSON.stringify(reqData), function(res, event){
                                if(res.success && res.data && res.data.products && res.data.products.length > 0){
                                    let originalReprintList = CCRZ.productListPageView.model.get('originalReprintList');
                                    _this.model.set('originalReprintList', isAdd?originalReprintList.concat(res.data.products):res.data.products);
                                    _this.itemViews = isAdd?_this.itemViews:[];
                                    reprintList = isAdd?CCRZ.productListPageView.model.get('reprintParseList'):[];
                                    let skus = new Set(), skuList = [];
                                    for(let i = 0; i < res.data.products.length; i++){
                                        skus.add(String(res.data.products[i]['REF2103']));
                                    }
                                    skuList = Array.from(skus);
                                    if(skuList.length > 0){
                                        let reqDataActive = {
                                            'skuList' : skuList
                                        };
                                        CCRZ.remoteModel.getActiveProducts(JSON.stringify(reqDataActive), function(response, eve){
                                            if(response && response.success && response.data){
                                                for(let i = 0; i < res.data.products.length; i++){
                                                    let itemModel = new searchModel();
                                                    for(let key in  res.data.products[i]){
                                                        if(key == 'THUMBWEB'){
                                                            itemModel.set('mediaURI', UTIL.parseImage(res.data.products[i][key]));
                                                        } else if(key == 'THUMB512'){
                                                            itemModel.set('media512URI', UTIL.parseImage(res.data.products[i][key]));
                                                        } else if(key == 'CSERVICE13'){
                                                            itemModel.set('CSERVICE13', ((res.data.products[i][key]).trim()==''?'KFS':res.data.products[i][key]));
                                                            itemModel.set('Name', (res.data.products[i][key]).trim());
                                                        } else if(key == 'UD_C32_1'){
                                                            itemModel.set('Layout', res.data.products[i][key]); //TBD
                                                        } else if(key == 'UD_C32_2'){
                                                            itemModel.set('Color', res.data.products[i][key]); //TBD
                                                        } else if(key == 'UD_TXT_1'){
                                                            itemModel.set('Genre', res.data.products[i][key]); //TBD
                                                        } else if(key == 'REF2103'){
                                                            itemModel.set('SKU', res.data.products[i][key]); //TBD
                                                        } else if(key == 'PUBLICATION'){
                                                            itemModel.set('Publication', res.data.products[i][key]); //TBD
                                                        } else if(key == 'CATEGOR215'){
                                                            itemModel.set('Language', res.data.products[i][key]); //TBD
                                                        } else {
                                                            itemModel.set(key, res.data.products[i][key]);
                                                        }
                                                    }
                                                    itemModel.set('sfid', res.data.products[i]['CIMAGEID']);
                                                    itemModel.set('isReprint', true);
                                                    if(itemModel.attributes.SKU != '' && !_.isUndefined(response.data[itemModel.attributes.SKU]) && response.data[itemModel.attributes.SKU]){
                                                        reprintList.push(itemModel);
                                                        itemsView.itemViews.push(new CCRZ.views.ProductItemView({model: itemModel}));
                                                    }
                                                }
                                                _this.model.set('reprintParseList', reprintList);
                                                _this.processFilterReprint();
                                                CCRZ.productListPageView.headerView.model.set('reprintSize', res.data.pageSize);
                                                CCRZ.productListPageView.headerView.model.set('offset', res.data.offSet);
                                                CCRZ.productListPageView.headerView.model.set('noResults', false);
                                                CCRZ.productListPageView.headerView.model.set('prodCount', res.data.total);
                                                CCRZ.productListPageView.headerView.model.set('renderedCount', reprintList.length);
                                                CCRZ.productListPageView.headerView.model.set('prodHasMore', false);
                                                CCRZ.productListPageView.headerView.model.set('renderHeader', true);
                                                CCRZ.productListPageView.headerView.render();
                                                CCRZ.productListPageView.productItemsView.model.set('isFilterRender', true);
                                                CCRZ.productListPageView.productItemsView.model.set('isRender', true);
                                                _this.render();
                                                CCRZ.plpSortView.render();
                                            } else {
                                                setDefaultPLPFilterInfo(_this);
                                            }
                                        });
                                    } else {
                                        setDefaultPLPFilterInfo(_this);
                                    }
                                } else {
                                    setDefaultPLPFilterInfo(_this);
                                }
                            });
                            CCRZ.plpSortView.render();
                        };
                        function setDefaultPLPFilterInfo(_this){
                            _this.itemViews = [];
                            CCRZ.productListPageView.headerView.model.set('noResults', true);
                            CCRZ.productListPageView.headerView.model.set('prodCount', 0);
                            CCRZ.productListPageView.headerView.model.set('renderedCount', 0);
                            CCRZ.productListPageView.headerView.model.set('prodHasMore', false);
                            CCRZ.productListPageView.headerView.model.set('renderHeader', true);
                            CCRZ.productListPageView.headerView.render();
                            CCRZ.productListPageView.productItemsView.model.set('isRender', true);
                            _this.render();
                        }
                        itemsView.processFilterReprint = function(){
                            let _this = this, filterView = CCRZ.productListFilterView, items = _this.model.get('reprintParseList');
                            filterView.specGroupCollection = new CCRZ.collections.SpecGroupList();
                            for(let i = 0; i < filterKey.length; i++){
                                let filtersByType = CCRZ.productListPageView.model.get('filter_' + filterKey[i]);
                                let filterMap = new Map();
                                if(typeof items != 'undefined' && items.length > 0){
                                    items.forEach(function(item){
                                        let value = item.attributes[filterKey[i]];
                                        if(typeof value != 'undefined' && value != null && value.trim() != ''){
                                            if(filterMap.has(value.trim())){
                                                let count = filterMap.get(value.trim());
                                                filterMap.set(value.trim(), count+1);
                                            } else {
                                                filterMap.set(value.trim(), 1);
                                            }
                                        }
                                    });
                                }
                                let filterList = Array.from(filterMap.keys()), specGroup = new CCRZ.models.SpecGroup();
                                specGroup.attributes.specValues = [];
                                specGroup.attributes.renderCount = filterList.length;
                                specGroup.attributes.name = filterKey[i];
                                specGroup.attributes['filterType'] = "Checkbox";
                                specGroup.attributes['isRender'] = true;
                                specGroup.attributes['collapsed'] = true;
                                if(filterList.length > 0){
                                    filterList.forEach(function(filterIndex){
                                        let specVal = new CCRZ.models.SpecValue();
                                        specVal.attributes.count = filterMap.get(filterIndex);
                                        specVal.attributes.value = filterIndex;
                                        if(filtersByType.length > 0){
                                            specVal.attributes.enabled = filtersByType.includes(filterIndex);
                                            specVal.attributes.selected = filtersByType.includes(filterIndex);
                                        } else {
                                            specVal.attributes.enabled = true;
                                        }
                                        specGroup.attributes.specValues.push(specVal);
                                    });
                                }
                                specGroup.attributes.specValues = new CCRZ.collections.SpecValueList(specGroup.attributes.specValues, {parse: true});
                                filterView.specGroupCollection.models.push(specGroup);
                            }
                            filterView.specGroupCollection.length = filterView.specGroupCollection.models.length;
                            filterView.specGroupsView = new CCRZ.views.SpecGroupListView({collection: filterView.specGroupCollection, model: filterView.model});
                            filterView.render();
                            filterView.specGroupsView.render();
                        };
                        itemsView.processItems = function(){
                            let _this = this;
                            _this.itemViews.forEach(function(item){
                                if(item.model.attributes.isSubscriptionAvailable){
                                    console.log('Product Name: ' + item.model.attributes.sfdcName);
                                    let subProdTerms = item.model.attributes['subProdTerms'];
                                    if(subProdTerms && subProdTerms.length > 0){
                                        let sptList = subProdTerms.filter(function(spt){
                                            return spt.KFB2BSptType != 'Reprint';
                                        });
                                        item.model.attributes['isShow'] = sptList.length >0?true:false;
                                    } else {
                                        item.model.attributes['isShow'] = false;
                                    }
                                } else {
                                    item.model.attributes['isShow'] = true;
                                }
                            });
                            _this.itemViews = _this.itemViews.filter(function(item){
                                return item.model.attributes['isShow'];
                            });
                            CCRZ.productListPageView.headerView.model.set('prodCount', _this.itemViews.length);
                            CCRZ.productListPageView.headerView.model.set('renderedCount', _this.itemViews.length);
                            CCRZ.productListPageView.headerView.render();
                            let isFilterRender = false;
                            if(CCRZ.productListFilterView && CCRZ.productListFilterView.specGroupsView 
                                && CCRZ.productListFilterView.specGroupsView.groupViews.length > 0){
                                    for(let i = 0; i < CCRZ.productListFilterView.specGroupsView.groupViews.length; i++){
                                        let groupView = CCRZ.productListFilterView.specGroupsView.groupViews[i];
                                        CCRZ.productListFilterView.specGroupsView.groupViews[i].model.attributes.collapsed = true;
                                        if(groupView.model.attributes && groupView.model.attributes.specValues
                                            && groupView.model.attributes.specValues.length > 0){
                                                groupView.model.attributes.specValues.models.forEach(function(item){
                                                    if(item.attributes.selected){
                                                        item.attributes['filterCount'] = _this.itemViews.length;
                                                        isFilterRender = true;
                                                    }
                                                });
                                        }
                                        groupView.render();
                                    }
                            }
                        };
                        itemsView.delegateEvents();
                        isProductItemsRefreshed = true, reprintList = [];
                        let searchText = CCRZ.productListPageView.model.get('searchText'), isReprint = CCRZ.productListPageView.model.get('isReprint');
                        if(isReprint){
                            CCRZ.productListPageView.model.set('isEndOfPageRender', false);
                            CCRZ.productListPageView.model.set('reprintSize', 100);
                            CCRZ.productListPageView.model.set('offset', 0);
                            CCRZ.productListPageView.model.set('originalReprintList', []);
                            CCRZ.productListPageView.model.set('reprintParseList', []);
                            for(let i = 0; i < filterKey.length; i++){
                                CCRZ.productListPageView.model.set('filter_' + filterKey[i], []);
                            }
                            let sortBy = CCRZ.productListPageView.model.get('sortBy'), sortOrder = CCRZ.productListPageView.model.get('sortOrder');
                            let reqData = {
                                'searchText': searchText + ' not EXCLUDE',
                                'type': 'search',
                                'UD_C64_1' : '1.0 Approved for Publication',
                                'sortType': (sortOrder == 'asc'?'+':'-') + sortBy,
                                'offset': '0',
                                'pageSize': '100',
                                'isPDP' : false
                            }
                            UTIL.disableScroll();
                            itemsView.fetchReprint(reqData, false);
                        } else {
                            CCRZ.productListPageView.productItemsView.model.set('isRender', true);
                            itemsView.render();
                        }
                    }
                });
                let isWLRefresh = false;
                // Wishlist Picker Modal View
                CCRZ.pubSub.on("view:wishlistPickerModal:refresh", function(view) {
                    if(!isWLRefresh){
                        view.render = function(isMain) {
                            this.setElement($(CCRZ.uiProperties.wishlistPickerModal.selector));
                            var v = this;
                            if (CCRZ.display.isPhone()){
                                v.$el.html(v.templatePhone(this.coll.toJSON()));
                            }else{
                                v.$el.html(v.templateDesktop(this.coll.toJSON()));
                            }
                            runDefaultJsFunctions();
                            if(!isMain || typeof isMain == 'undefined'){
                                UTIL.hideLoader();
                            }
                            CCRZ.pubSub.trigger("view:"+this.viewName+":refresh", this);
                        };
                        view.addItem = function(event) {
                            var objLink = $(event.target), parentObj = objLink.closest('.wishFinder'), newName = '';
                            var id = objLink.data("id"), type= objLink.data("type");
                            if(type == 'select' || (id == '-1')){
                                this.processAddItem(parentObj, id, newName);
                            } else {
                                CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-Error-WL", 'Add a name before adding a wishlist!'));
                                setTimeout(function(){
                                    $('.messagingSection-Error-WL').css('display', 'none');
                                }, 3000);
                            }
                        };
                        view.processAddItem = function(parentObj, val, newName) {
                            UTIL.showLoader();
                            var sku = parentObj.data("sku");
                            var v = this;
                            this.invokeContainerLoadingCtx($('.deskLayout'), 'handleAddtoWishlist', sku, val, newName, function(response) {
                                CCRZ.pubSub.trigger('refreshWishlists', val);
                                if (val == '-1') {
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "messagingSection-Info-WL", 'New Wishlist has been created: ' + newName));
                                v.refresh();
                                } else {
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "messagingSection-Info-WL", 'Product added to the Wishlist!'));
                                    UTIL.hideLoader();
                                }
                                setTimeout(function(){
                                    $('.messagingSection-Info-WL').css('display', 'none');
                                }, 3000);
                            });
                        };
                        view.delegateEvents();
                        isWLRefresh = true;
                        view.render(true);
                    }
                });
                //Slider value Change fix for UI Slider (Wordaround)
                CCRZ.pubSub.on("view:specGroupView:refresh", function(filterView) {
                    if(filterView.model.attributes.isRender && CCRZ.productListPageView.model.get('isReprint')){
                        UTIL.hideLoader();
                    }
                    filterView.events["update .cc_slider"] = 'performRangeFilter';
                    filterView.events["click .cc_filter_checkbox"] = 'toggleSelected';
                    filterView.events["click .reprintFilterSelect"] = 'toggleReprint';
                    filterView.events["click .cc_collapse_group"] = 'toggleCollapseCustom';
                    filterView.toggleCollapseCustom = function(event, values){
                        var objLink = $(event.currentTarget);
                        var id = objLink.data('target');
                        var $element = $(id);
                        if(this.model.get('collapsed')){
                            //$element.removeClass('show');
                        } else {
                            //$element.addClass('show');
                        }
                        $element.collapse('toggle')
                        this.model.set('collapsed', !this.model.get('collapsed'), {silent: true});
                    };
                    filterView.performRangeFilter = function(event, values){
                        var objLink = $(event.currentTarget);
                        this.model.set('filterMin', values[0], {silent: true});
                        this.model.set('filterMax', values[1], {silent: true});
                        var filter = _.pick(this.model.toJSON(), 'sfid', 'name', 'filterType', 'filterMin', 'filterMax');
                    
                        CCRZ.appliedFilters.set(filter, {parse: false, remove: false, merge: true});
                        if (CCRZ.ga) {
                            CCRZ.ga.handleFeatureFilter(objLink);
                        }
                        CCRZ.pubSub.trigger("view:productListFilterView:applyFilters", CCRZ.appliedFilters);
                        //UI Silder render on changing values, timeout for workaround to fix UI silder
                        setTimeout(function(){
                            CCRZ.productListFilterView.specGroupsView.postRender();
                        }, 1500);
                    };
                    filterView.renderDesktop = function(){
                        this.$el.html(this.template(this.model.toJSON()));
                        if(typeof this.model.attributes.isShowLoader != 'undefined' && !this.model.attributes.isShowLoader){
                            UTIL.hideLoader();
                        }
                        return this;
                    };
                    filterView.toggleReprint = function(event){
                        UTIL.showLoader();
                        var objLink = $(event.currentTarget), isChecked = objLink.is(':checked');
                        var filter = _.pick(this.model.toJSON(), 'sfid', 'name', 'filterType');

                        var specGroupValues = this.model.get('specValues');
                        var toUpdate = specGroupValues.find({value: objLink.attr("data-value")});
                        toUpdate.set('selected', isChecked);
                        this.model.set('isShowLoader', true);
                        let filterVal = toUpdate.get('value'), orginalFilterList = CCRZ.productListPageView.model.attributes['filter_' + filter.name];
                        if(isChecked){
                            orginalFilterList.push(filterVal);
                        } else {
                            orginalFilterList.forEach(function(filterItem){
                                if(filterItem == filterVal){
                                    orginalFilterList.pop();
                                }
                            });
                        }
                        CCRZ.productListPageView.model.set('filter_' + filter.name, orginalFilterList);
                        let reqData = {
                            'searchText': CCRZ.productListPageView.model.get('searchText') + ' not EXCLUDE',
                            'type': 'search',
                            'UD_C64_1' : '1.0 Approved for Publication',
                            'sortType': '-pubdate',
                            'offset': '0',
                            'pageSize': '100',
                            'isPDP' : false
                        }
                        filterKey.forEach(function(key){
                            let filterList = CCRZ.productListPageView.model.attributes['filter_' + key];
                            if(filterList.length > 0){
                                reqData['filter' + key] = filterList[0];
                            }
                        });
                        filterView.model.set('isRender', false);
                        CCRZ.productListPageView.model.set('isEndOfPageRender', false);
                        window.scroll(0,0);
                        UTIL.disableScroll();
                        console.log('Filter callout started!');
                        CCRZ.productListPageView.productItemsView.fetchReprint(reqData, false);
                    };
                    filterView.toggleSelected = function(event){
                        UTIL.showLoader();
                        var objLink = $(event.currentTarget);
                        var filter = _.pick(this.model.toJSON(), 'sfid', 'name', 'filterType');

                        var specGroupValues = this.model.get('specValues');
                        var toUpdate = specGroupValues.find({value: objLink.attr("data-value")});
                        toUpdate.set('selected', objLink.is(':checked'));

                        var appliedFilters = _.where(specGroupValues.toJSON(), {selected: true});
                        if(appliedFilters.length != 0){
                        filter.specValues = appliedFilters;
                        CCRZ.appliedFilters.set(filter, {parse: false, remove: false, merge: true});
                        }else{
                        CCRZ.appliedFilters.remove(filter);
                        }
                        if (CCRZ.ga && objLink.is(':checked')) {
                        CCRZ.ga.handleFeatureFilter(objLink);
                        }
                        CCRZ.pubSub.trigger("view:productListFilterView:applyFilters", CCRZ.appliedFilters);
                        setTimeout(function(){
                            CCRZ.productListFilterView.specGroupsView.postRender();
                        }, 2000);
                    };
                    filterView.delegateEvents();
                });
            }
            
    }
});

